diff --git a/salt/modules/virt.py b/salt/modules/virt.py
index c8e046a47a..a78c21e323 100644
--- a/salt/modules/virt.py
+++ b/salt/modules/virt.py
@@ -5522,7 +6279,7 @@ def pool_undefine(name, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.pool_undefine default
-    '''
+    """
     conn = __get_conn(**kwargs)
     try:
         pool = conn.storagePoolLookupByName(name)
@@ -5532,7 +6289,7 @@ def pool_undefine(name, **kwargs):
 
 
 def pool_delete(name, **kwargs):
-    '''
+    """
     Delete the resources of a defined libvirt storage pool.
 
     :param name: libvirt storage pool name
@@ -5547,17 +6304,33 @@ def pool_delete(name, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.pool_delete default
-    '''
+    """
     conn = __get_conn(**kwargs)
     try:
         pool = conn.storagePoolLookupByName(name)
+        desc = ElementTree.fromstring(pool.XMLDesc())
+
+        # Is there a secret that we generated and would need to be removed?
+        # Don't remove the other secrets
+        auth_node = desc.find("source/auth")
+        if auth_node is not None:
+            auth_types = {
+                "ceph": libvirt.VIR_SECRET_USAGE_TYPE_CEPH,
+                "iscsi": libvirt.VIR_SECRET_USAGE_TYPE_ISCSI,
+            }
+            secret_type = auth_types[auth_node.get("type")]
+            secret_usage = auth_node.find("secret").get("usage")
+            if secret_type and "pool_{}".format(name) == secret_usage:
+                secret = conn.secretLookupByUsage(secret_type, secret_usage)
+                secret.undefine()
+
         return not bool(pool.delete(libvirt.VIR_STORAGE_POOL_DELETE_NORMAL))
     finally:
         conn.close()
 
 
 def pool_refresh(name, **kwargs):
-    '''
+    """
     Refresh a defined libvirt storage pool.
 
     :param name: libvirt storage pool name
@@ -5572,7 +6345,7 @@ def pool_refresh(name, **kwargs):
     .. code-block:: bash
 
         salt '*' virt.pool_refresh default
-    '''
+    """
     conn = __get_conn(**kwargs)
     try:
         pool = conn.storagePoolLookupByName(name)
@@ -5581,8 +6354,8 @@ def pool_refresh(name, **kwargs):
         conn.close()
 
 
-def pool_set_autostart(name, state='on', **kwargs):
-    '''
+def pool_set_autostart(name, state="on", **kwargs):
+    """
     Set the autostart flag on a libvirt storage pool so that the storage pool
     will start with the host system on reboot.
 
@@ -5600,17 +6373,17 @@ def pool_set_autostart(name, state='on', **kwargs):
     .. code-block:: bash
 
         salt "*" virt.pool_set_autostart <pool> <on | off>
-    '''
+    """
     conn = __get_conn(**kwargs)
     try:
         pool = conn.storagePoolLookupByName(name)
-        return not bool(pool.setAutostart(1 if state == 'on' else 0))
+        return not bool(pool.setAutostart(1 if state == "on" else 0))
     finally:
         conn.close()
 
 
 def pool_list_volumes(name, **kwargs):
-    '''
+    """
     List the volumes contained in a defined libvirt storage pool.
 
     :param name: libvirt storage pool name
@@ -5625,7 +6398,7 @@ def pool_list_volumes(name, **kwargs):
     .. code-block:: bash
 
         salt "*" virt.pool_list_volumes <pool>
-    '''
+    """
     conn = __get_conn(**kwargs)
     try:
         pool = conn.storagePoolLookupByName(name)
@@ -5635,27 +6408,28 @@ def pool_list_volumes(name, **kwargs):
 
 
 def _get_storage_vol(conn, pool, vol):
-    '''
+    """
     Helper function getting a storage volume. Will throw a libvirtError
     if the pool or the volume couldn't be found.
 
     :param conn: libvirt connection object to use
     :param pool: pool name
     :param vol: volume name
-    '''
+    """
     pool_obj = conn.storagePoolLookupByName(pool)
     return pool_obj.storageVolLookupByName(vol)
 
 
 def _is_valid_volume(vol):
-    '''
+    """
     Checks whether a volume is valid for further use since those may have disappeared since
     the last pool refresh.
-    '''
+    """
     try:
         # Getting info on an invalid volume raises error and libvirt logs an error
         def discarder(ctxt, error):  # pylint: disable=unused-argument
             log.debug("Ignore libvirt error: %s", error[2])
+
         # Disable the libvirt error logging
         libvirt.registerErrorHandler(discarder, None)
         vol.info()
@@ -5667,20 +6441,34 @@ def _is_valid_volume(vol):
 
 
 def _get_all_volumes_paths(conn):
-    '''
+    """
     Extract the path and backing stores path of all volumes.
 
     :param conn: libvirt connection to use
-    '''
-    volumes = [vol for l in
-                [obj.listAllVolumes() for obj in conn.listAllStoragePools()
-                    if obj.info()[0] == libvirt.VIR_STORAGE_POOL_RUNNING] for vol in l]
-    return {vol.path(): [path.text for path in ElementTree.fromstring(vol.XMLDesc()).findall('.//backingStore/path')]
-            for vol in volumes if _is_valid_volume(vol)}
+    """
+    volumes = [
+        vol
+        for l in [
+            obj.listAllVolumes()
+            for obj in conn.listAllStoragePools()
+            if obj.info()[0] == libvirt.VIR_STORAGE_POOL_RUNNING
+        ]
+        for vol in l
+    ]
+    return {
+        vol.path(): [
+            path.text
+            for path in ElementTree.fromstring(vol.XMLDesc()).findall(
+                ".//backingStore/path"
+            )
+        ]
+        for vol in volumes
+        if _is_valid_volume(vol)
+    }
 
 
 def volume_infos(pool=None, volume=None, **kwargs):
-    '''
+    """
     Provide details on a storage volume. If no volume name is provided, the infos
     all the volumes contained in the pool are provided. If no pool is provided,
     the infos of the volumes of all pools are output.
@@ -5698,7 +6486,7 @@ def volume_infos(pool=None, volume=None, **kwargs):
     .. code-block:: bash
 
         salt "*" virt.volume_infos <pool> <volume>
-    '''
+    """
     result = {}
     conn = __get_conn(**kwargs)
     try:
@@ -5709,52 +6497,88 @@ def volume_infos(pool=None, volume=None, **kwargs):
         except CommandExecutionError:
             # Having no VM is not an error here.
             domains_list = []
-        disks = {domain.name():
-                 {node.get('file') for node
-                  in ElementTree.fromstring(domain.XMLDesc(0)).findall('.//disk/source/[@file]')}
-                 for domain in domains_list}
+        disks = {
+            domain.name(): {
+                node.get("file")
+                for node in ElementTree.fromstring(domain.XMLDesc(0)).findall(
+                    ".//disk/source/[@file]"
+                )
+            }
+            for domain in domains_list
+        }
 
         def _volume_extract_infos(vol):
-            '''
+            """
             Format the volume info dictionary
 
             :param vol: the libvirt storage volume object.
-            '''
-            types = ['file', 'block', 'dir', 'network', 'netdir', 'ploop']
+            """
+            types = ["file", "block", "dir", "network", "netdir", "ploop"]
             infos = vol.info()
 
+            vol_xml = ElementTree.fromstring(vol.XMLDesc())
+            backing_store_path = vol_xml.find("./backingStore/path")
+            backing_store_format = vol_xml.find("./backingStore/format")
+            backing_store = None
+            if backing_store_path is not None:
+                backing_store = {
+                    "path": backing_store_path.text,
+                    "format": backing_store_format.get("type")
+                    if backing_store_format is not None
+                    else None,
+                }
+
+            format_node = vol_xml.find("./target/format")
+
             # If we have a path, check its use.
             used_by = []
             if vol.path():
-                as_backing_store = {path for (path, all_paths) in backing_stores.items() if vol.path() in all_paths}
-                used_by = [vm_name for (vm_name, vm_disks) in disks.items()
-                           if vm_disks & as_backing_store or vol.path() in vm_disks]
+                as_backing_store = {
+                    path
+                    for (path, all_paths) in backing_stores.items()
+                    if vol.path() in all_paths
+                }
+                used_by = [
+                    vm_name
+                    for (vm_name, vm_disks) in disks.items()
+                    if vm_disks & as_backing_store or vol.path() in vm_disks
+                ]
 
             return {
-                'type': types[infos[0]] if infos[0] < len(types) else 'unknown',
-                'key': vol.key(),
-                'path': vol.path(),
-                'capacity': infos[1],
-                'allocation': infos[2],
-                'used_by': used_by,
+                "type": types[infos[0]] if infos[0] < len(types) else "unknown",
+                "key": vol.key(),
+                "path": vol.path(),
+                "capacity": infos[1],
+                "allocation": infos[2],
+                "used_by": used_by,
+                "backing_store": backing_store,
+                "format": format_node.get("type") if format_node is not None else None,
             }
 
-        pools = [obj for obj in conn.listAllStoragePools()
-                    if (pool is None or obj.name() == pool) and obj.info()[0] == libvirt.VIR_STORAGE_POOL_RUNNING]
-        vols = {pool_obj.name(): {vol.name(): _volume_extract_infos(vol)
-                                  for vol in pool_obj.listAllVolumes()
-                                  if (volume is None or vol.name() == volume) and _is_valid_volume(vol)}
-                for pool_obj in pools}
+        pools = [
+            obj
+            for obj in conn.listAllStoragePools()
+            if (pool is None or obj.name() == pool)
+            and obj.info()[0] == libvirt.VIR_STORAGE_POOL_RUNNING
+        ]
+        vols = {
+            pool_obj.name(): {
+                vol.name(): _volume_extract_infos(vol)
+                for vol in pool_obj.listAllVolumes()
+                if (volume is None or vol.name() == volume) and _is_valid_volume(vol)
+            }
+            for pool_obj in pools
+        }
         return {pool_name: volumes for (pool_name, volumes) in vols.items() if volumes}
     except libvirt.libvirtError as err:
-        log.debug('Silenced libvirt error: %s', str(err))
+        log.debug("Silenced libvirt error: %s", str(err))
     finally:
         conn.close()
     return result
 
 
 def volume_delete(pool, volume, **kwargs):
-    '''
+    """
     Delete a libvirt managed volume.
 
     :param pool: libvirt storage pool name
@@ -5770,10 +6594,222 @@ def volume_delete(pool, volume, **kwargs):
     .. code-block:: bash
 
         salt "*" virt.volume_delete <pool> <volume>
-    '''
+    """
     conn = __get_conn(**kwargs)
     try:
         vol = _get_storage_vol(conn, pool, volume)
         return not bool(vol.delete())
     finally:
         conn.close()
+
+
+def volume_define(
+    pool,
+    name,
+    size,
+    allocation=0,
+    format=None,
+    type=None,
+    permissions=None,
+    backing_store=None,
+    nocow=False,
+    **kwargs
+):
+    """
+    Create libvirt volume.
+
+    :param pool: name of the pool to create the volume in
+    :param name: name of the volume to define
+    :param size: capacity of the volume to define in MiB
+    :param allocation: allocated size of the volume in MiB. Defaults to 0.
+    :param format:
+        volume format. The allowed values are depending on the pool type.
+        Check the virt.pool_capabilities output for the possible values and the default.
+    :param type:
+        type of the volume. One of file, block, dir, network, netdiri, ploop or None.
+        By default, the type is guessed by libvirt from the pool type.
+    :param permissions:
+        Permissions to set on the target folder. This is mostly used for filesystem-based
+        pool types. See :ref:`pool-define-permissions` for more details on this structure.
+    :param backing_store:
+        dictionary describing a backing file for the volume. It must contain a ``path``
+        property pointing to the base volume and a ``format`` property defining the format
+        of the base volume.
+
+        The base volume format will not be guessed for security reasons and is thus mandatory.
+    :param nocow: disable COW for the volume.
+    :param connection: libvirt connection URI, overriding defaults
+    :param username: username to connect with, overriding defaults
+    :param password: password to connect with, overriding defaults
+
+    .. rubric:: CLI Example:
+
+    Volume on ESX:
+
+    .. code-block:: bash
+
+        salt '*' virt.volume_define "[local-storage]" myvm/myvm.vmdk vmdk 8192
+
+    QCow2 volume with backing file:
+
+    .. code-block:: bash
+
+        salt '*' virt.volume_define default myvm.qcow2 qcow2 8192 \
+                            permissions="{'mode': '0775', 'owner': '123', 'group': '345'"}" \
+                            backing_store="{'path': '/path/to/base.img', 'format': 'raw'}" \
+                            nocow=True
+
+    .. versionadded:: Sodium
+    """
+    ret = False
+    try:
+        conn = __get_conn(**kwargs)
+        pool_obj = conn.storagePoolLookupByName(pool)
+        pool_type = ElementTree.fromstring(pool_obj.XMLDesc()).get("type")
+        new_allocation = allocation
+        if pool_type == "logical" and size != allocation:
+            new_allocation = size
+        xml = _gen_vol_xml(
+            name,
+            size,
+            format=format,
+            allocation=new_allocation,
+            type=type,
+            permissions=permissions,
+            backing_store=backing_store,
+            nocow=nocow,
+        )
+        ret = _define_vol_xml_str(conn, xml, pool=pool)
+    except libvirt.libvirtError as err:
+        raise CommandExecutionError(err.get_error_message())
+    finally:
+        conn.close()
+    return ret
+
+
+def _volume_upload(conn, pool, volume, file, offset=0, length=0, sparse=False):
+    """
+    Function performing the heavy duty for volume_upload but using an already
+    opened libvirt connection.
+    """
+
+    def handler(stream, nbytes, opaque):
+        return os.read(opaque, nbytes)
+
+    def holeHandler(stream, opaque):
+        """
+        Taken from the sparsestream.py libvirt-python example.
+        """
+        fd = opaque
+        cur = os.lseek(fd, 0, os.SEEK_CUR)
+
+        try:
+            data = os.lseek(fd, cur, os.SEEK_DATA)
+        except OSError as e:
+            if e.errno != 6:
+                raise e
+            else:
+                data = -1
+        if data < 0:
+            inData = False
+            eof = os.lseek(fd, 0, os.SEEK_END)
+            if eof < cur:
+                raise RuntimeError("Current position in file after EOF: {}".format(cur))
+            sectionLen = eof - cur
+        else:
+            if data > cur:
+                inData = False
+                sectionLen = data - cur
+            else:
+                inData = True
+
+                hole = os.lseek(fd, data, os.SEEK_HOLE)
+                if hole < 0:
+                    raise RuntimeError("No trailing hole")
+
+                if hole == data:
+                    raise RuntimeError("Impossible happened")
+                else:
+                    sectionLen = hole - data
+        os.lseek(fd, cur, os.SEEK_SET)
+        return [inData, sectionLen]
+
+    def skipHandler(stream, length, opaque):
+        return os.lseek(opaque, length, os.SEEK_CUR)
+
+    stream = None
+    fd = None
+    ret = False
+    try:
+        pool_obj = conn.storagePoolLookupByName(pool)
+        vol_obj = pool_obj.storageVolLookupByName(volume)
+
+        stream = conn.newStream()
+        fd = os.open(file, os.O_RDONLY)
+        vol_obj.upload(
+            stream,
+            offset,
+            length,
+            libvirt.VIR_STORAGE_VOL_UPLOAD_SPARSE_STREAM if sparse else 0,
+        )
+        if sparse:
+            stream.sparseSendAll(handler, holeHandler, skipHandler, fd)
+        else:
+            stream.sendAll(handler, fd)
+        ret = True
+    except libvirt.libvirtError as err:
+        raise CommandExecutionError(err.get_error_message())
+    finally:
+        if fd:
+            try:
+                os.close(fd)
+            except OSError as err:
+                if stream:
+                    stream.abort()
+                if ret:
+                    raise CommandExecutionError(
+                        "Failed to close file: {0}".format(err.strerror)
+                    )
+        if stream:
+            try:
+                stream.finish()
+            except libvirt.libvirtError as err:
+                if ret:
+                    raise CommandExecutionError(
+                        "Failed to finish stream: {0}".format(err.get_error_message())
+                    )
+    return ret
+
+
+def volume_upload(pool, volume, file, offset=0, length=0, sparse=False, **kwargs):
+    """
+    Create libvirt volume.
+
+    :param pool: name of the pool to create the volume in
+    :param name: name of the volume to define
+    :param file: the file to upload to the volume
+    :param offset: where to start writing the data in the volume
+    :param length: amount of bytes to transfer to the volume
+    :param sparse: set to True to preserve data sparsiness.
+    :param connection: libvirt connection URI, overriding defaults
+    :param username: username to connect with, overriding defaults
+    :param password: password to connect with, overriding defaults
+
+    .. rubric:: CLI Example:
+
+    .. code-block:: bash
+
+        salt '*' virt.volume_upload default myvm.qcow2 /path/to/disk.qcow2
+
+    .. versionadded:: Sodium
+    """
+    conn = __get_conn(**kwargs)
+
+    ret = False
+    try:
+        ret = _volume_upload(
+            conn, pool, volume, file, offset=offset, length=length, sparse=sparse
+        )
+    finally:
+        conn.close()
+    return ret
